-- Get a DB of zones and continents
local zonei, zonec, zonenames = {}, {}, {}
for ci,c in pairs{GetMapContinents()} do
	zonenames[ci] = {GetMapZones(ci)}
	for zi,z in pairs(zonenames[ci]) do
		zonei[z], zonec[z] = zi, ci
	end
end

-- Add waypoint arrow
local function AddWaypoint(zone, x, y, desc, c, z)
  local zi, zc = z or zone and zonei[zone], c or zone and zonec[zone]
	if not zi then
		zi, zc = GetCurrentMapZone(), GetCurrentMapContinent()
	end

	if TomTom then return TomTom:AddZWaypoint(zc, zi, x, y, desc, false) end
end

-- Set waypoint arrow
local function SetNpcArrow(info)
  if TomTom then return TomTom:SetCrazyArrow(info.uid, 1, info.Name .. " <" .. info.Type .. ">") end
end

-- Set Waypoint to a NPC
function ProGuide:SetNpcWaypoint(id)
  if id and ProGuide.Data.Npc[id] then
    if ProGuide.Data.Npc[id].uid and TomTom:IsValidWaypoint(ProGuide.Data.Npc[id].uid) then
      SetNpcArrow(ProGuide.Data.Npc[id])
    else
      ProGuide.Data.Npc[id].uid = AddWaypoint(ProGuide.Data.Npc[id].Loc.zone, ProGuide.Data.Npc[id].Loc.x, ProGuide.Data.Npc[id].Loc.y, ProGuide.Data.Npc[id].Name .. " <" .. ProGuide.Data.Npc[id].Type .. ">")
    end
  end
end